<?php

/*-----------------------------------------------------------------
// Fonctions pour etre compatible avec les acces restreint
------------------------------------------------------------------*/

// Signaletique acces restreints
function cisquel_logo_ari($id_rubrique) {
	$return = "";

	$f = cisquel_fonction_rubrique_restreinte();
	if ($f!="non") {
		if ($f($id_rubrique)) {
			$return = "<div class='ar'>"._T('cisquel:eq_ar')."</div>";
		}
	}

	$fec = cisquel_fonction_rubrique_ec();
	if ($fec!="non") {
		if ($fec($id_rubrique))
			$return = '<div class="ari">'._T('cisquel:eq_ari').'</div>';
	}

	return $return;
}

// Rubrique EC
function cisquel_rubrique_ec($id_rubrique) {
	$return = "non";

	$fec = cisquel_fonction_rubrique_ec();
	if ($fec!="non") {
		if ($fec($id_rubrique))
			$return = "oui";
	}

	return $return;
}



function cisquel_fonction_rubrique_restreinte() {
	static $return;
	
	if (!$return) {
		if (function_exists('ciar_rub_ar'))
			$return = "ciar_rub_ar";
		else
			$return = "non";
	}

	return $return;
}

function cisquel_fonction_rubrique_ec() {
	static $return;
	
	if (!$return) {
		if (function_exists('ciar_rub_ec'))
			$return = "ciar_rub_ec";
		else
			$return = "non";
	}

	return $return;
}


// cisquel_post_autobr : transforme les sauts de ligne en _
// en tenant compte de certains cas particuliers
function cisquel_post_autobr($texte, $delim="\n_ ") {

	// cas des tableaux HTML saisis manuellement
    $preg_tableaux = ',</?(table|tr|td|th|thead|tbody)(.*?)>,iS';    
	$recherches = array();
	$items = explode('>',$texte);	
	foreach ($items as $item) {
		$posdebut = strrpos($item, "<");
		if ($posdebut !== false) {
			$replace = substr($item,$posdebut).">";
			$search = $replace."\r\n";
			if (!in_array($search,$recherches)) {
				$recherches[] = $search;
				if (preg_match($preg_tableaux, $replace)) {
					$texte = str_replace($search,$replace,$texte);
				}
			}
		}
	}


	$texte = str_replace("\r\n", "\r", $texte);
	$texte = str_replace("\r", "\n", $texte);

	if (preg_match(",\n+$,", $texte, $fin))
		$texte = substr($texte, 0, -strlen($fin = $fin[0]));
	else
		$fin = '';

	$texte = echappe_html($texte, '', true);


	$debut = '';
	$suite = $texte;
	while ($t = strpos('-'.$suite, "\n", 1)) {
		$debut .= substr($suite, 0, $t-1);
		$suite = substr($suite, $t);
		$car = substr($suite, 0, 1);
		if (($car<>'-') AND ($car<>'_') AND ($car<>"\n") AND ($car<>"|") AND ($car<>"}")
		AND !preg_match(',^\s*(\n|</?(quote|div)|$),S',($suite))
		AND !preg_match(',</?(quote|div)> *$,iS', $debut)) {
			$debut .= $delim;
		} else
			$debut .= "\n";
		if (preg_match(",^\n+,", $suite, $regs)) {
			$debut.=$regs[0];
			$suite = substr($suite, strlen($regs[0]));
		}
	}
	$texte = $debut.$suite;

	$texte = echappe_retour($texte);
	return $texte.$fin;
}

/*-----------------------------------------------------------------
// Fonctions pour les recherches
------------------------------------------------------------------*/

function cisquel_filtrer_recherche($recherche, $verif_alpha=false) {
	$safe = '';
	$verif = true;

	// recherche avant traitement
	if ($t = _request('recherche'))	{
		$t = trim($t);
	// recherche apres traitement
	} else {	
		$t = trim($recherche);
		include_spip('inc/filtres');	
		$t = filtrer_entites($t);
	}

	if ($t) {
		// supprimer les accents
		include_spip('inc/charsets');
		$tsa = translitteration($t);
	
		// interdire les caracteres dangereux
		// limiter  a-zA-Z0-9 et aux espaces, underscores, apostrophe, guillemets
		$tableau = array(" ","_","'",'"');
		$tscs = str_replace($tableau,'',$tsa);		
		if (!ctype_alnum($tscs)) {
			$verif = false;

			// passer le cas echeant en iso pour avoir la meme longueur avec ou sans accent en utf-8	
			if ($GLOBALS['meta']['charset'] != 'iso-8859-1')
				$tiso = iconv(strtoupper($GLOBALS['meta']['charset']), "ISO-8859-1", $t);
			else
				$tiso = $t;

			// enlever les caracteres speciaux
			$longueur = strlen($tsa);
		    for ($i = 0; $i < $longueur; $i++){
		    	if (ctype_alnum($tsa[$i]) OR in_array($tsa[$i], $tableau))
		    		$safe .= $tiso[$i];
		    	else
		        	$safe .= ' ';
		    }
			// repasser le cas echeant dans le charset du site
			if ($GLOBALS['meta']['charset'] != 'iso-8859-1')
				$safe = iconv("ISO-8859-1", strtoupper($GLOBALS['meta']['charset']), $safe);
		    
		} else {
			$safe = $t;
		}

	    // supprimer les espaces doubles
	    $safe = trim(preg_replace ( '~\s{2,}~' , ' ' , $safe )); 
	}

    if ($verif_alpha)
    	return $verif;
    
   	return $safe;
}

function cisquel_recherche_autorise($recherche) {
	static $resultat = array();

	if (isset($GLOBALS['cisquel_recherche_sans_filtre']) AND $GLOBALS['cisquel_recherche_sans_filtre']=='oui') {
		$return = 'oui';
	} else {
		if (isset($resultat[$recherche])) {
			$return = $resultat[$recherche];
		} else {
			if (cisquel_filtrer_recherche($recherche, true))
				$return = 'oui';
			else
				$return = 'non';
				
			$resultat[$recherche] = $return;
		}
	}
				
	return $return;	
}

function cisquel_accesinterdit($autorise='oui') {
	if ($autorise=='non') {
		include_spip('inc/headers');
		redirige_par_entete(generer_url_public('recherche_interdit'));
	}
	return '';
}

function cisquel_date_vers_age($date) {
	$date_en = '';
	$return = '';

	// verifier
	$date_en = cisquel_verifier_et_convertir_date($date);
	
	// calcul de l'age en jours
	if ($date_en) {
		$ref_time = time();
		$decal = date("U",$ref_time) - date("U", strtotime($date_en));
		$return = intval($decal/(3600*24));		
	}
	
	return $return;
}

function cisquel_age_vers_date($age) {
	$return = '';

	// calcul de l'age en jours
	if ($age = intval($age)) {
		$ref_time = time();
		$timestamp = date("U",$ref_time) - intval($age*3600*24);
		$return = date("Y-m-d",$timestamp);		
	}
	
	return $return;
}

function cisquel_verifier_date($a) {
	$return = '';

   	if (isset($a) AND $a!="") {
	    list($dd,$mm,$yy) = explode("/",$a);
	    if ($dd!="" && $mm!="" && $yy!="") {
		    if (is_numeric($yy) && is_numeric($mm) && is_numeric($dd)) {
		            if (checkdate($mm,$dd,$yy))
						$return = $dd."/".$mm."/".$yy;
		    }
	    } 
   	}

   	return $return;
}

function cisquel_verifier_et_convertir_date($a) {
	$return = false;

   	if (isset($a) AND $a!="") {
	    list($dd,$mm,$yy) = explode("/",$a);
	    if ($dd!="" && $mm!="" && $yy!="") {
		    if (is_numeric($yy) && is_numeric($mm) && is_numeric($dd)) {
		            if (checkdate($mm,$dd,$yy))
						$return = $yy."-".$mm."-".$dd;
		    }
	    } 
   	}

   	return $return;
}

?>